# 4.0.0

Release date: `2018-10-30`

New authentication process using the **user's browser**.

Changes in command line arguments:

- Removed `proxy-exceptions`
- Removed `proxy-type`

## Core

- [NXDRIVE-659](https://jira.nuxeo.com/browse/NXDRIVE-659): Fix permissions awareness when resuming synchronization
- [NXDRIVE-691](https://jira.nuxeo.com/browse/NXDRIVE-691): Upgrade to Python 3 (**breaking change**)
- [NXDRIVE-692](https://jira.nuxeo.com/browse/NXDRIVE-692): Upgrade from PyQt4 to PyQt5 (**breaking change**)
- [NXDRIVE-825](https://jira.nuxeo.com/browse/NXDRIVE-825): Rely on the Python client for all Nuxeo API calls (**breaking change**)
- [NXDRIVE-876](https://jira.nuxeo.com/browse/NXDRIVE-876): Make NotFound exception inherits from OSError
- [NXDRIVE-922](https://jira.nuxeo.com/browse/NXDRIVE-922): Move custom exceptions to exceptions.py
- [NXDRIVE-1068](https://jira.nuxeo.com/browse/NXDRIVE-1068): Move proxy support to a dedicated module (**breaking change**)
- [NXDRIVE-1171](https://jira.nuxeo.com/browse/NXDRIVE-1171): Handle latin accents in Windows session usernames
- [NXDRIVE-1201](https://jira.nuxeo.com/browse/NXDRIVE-1201): Adapt Drive for new Trash API behavior
- [NXDRIVE-1210](https://jira.nuxeo.com/browse/NXDRIVE-1210): Sanitize exported objects
- [NXDRIVE-1238](https://jira.nuxeo.com/browse/NXDRIVE-1238): \[GDPR\] Remove the username from statistics
- [NXDRIVE-1239](https://jira.nuxeo.com/browse/NXDRIVE-1239): DirectEdit should work after network loss
- [NXDRIVE-1240](https://jira.nuxeo.com/browse/NXDRIVE-1240): Use black for a big code clean-up
- [NXDRIVE-1241](https://jira.nuxeo.com/browse/NXDRIVE-1241): Set the --consider-ssl-errors argument default value to True
- [NXDRIVE-1242](https://jira.nuxeo.com/browse/NXDRIVE-1242): Use type annotations everywhere
- [NXDRIVE-1256](https://jira.nuxeo.com/browse/NXDRIVE-1256): Fix the missing synchronization folder icon on Windows
- [NXDRIVE-1258](https://jira.nuxeo.com/browse/NXDRIVE-1258): Better handle unknown digest algorithms
- [NXDRIVE-1262](https://jira.nuxeo.com/browse/NXDRIVE-1262): Do not rely on XCode on macOS
- [NXDRIVE-1279](https://jira.nuxeo.com/browse/NXDRIVE-1279): Use flake8 for another clean-up round
- [NXDRIVE-1286](https://jira.nuxeo.com/browse/NXDRIVE-1286): Ignore documents when the system cannot find the file
- [NXDRIVE-1291](https://jira.nuxeo.com/browse/NXDRIVE-1291): Use the user's browser for authentication
- [NXDRIVE-1292](https://jira.nuxeo.com/browse/NXDRIVE-1292): Make the authentication easier to customize
- [NXDRIVE-1287](https://jira.nuxeo.com/browse/NXDRIVE-1287): Better server error 500 reporting
- [NXDRIVE-1303](https://jira.nuxeo.com/browse/NXDRIVE-1303): Fix using the bind-server CLI argument without --local-folder
- [NXDRIVE-1307](https://jira.nuxeo.com/browse/NXDRIVE-1307): Do not use nxdrive protocol from the FinderSync extension
- [NXDRIVE-1320](https://jira.nuxeo.com/browse/NXDRIVE-1320): Review the communication between Drive and the FinderSync extension
- [NXDRIVE-1339](https://jira.nuxeo.com/browse/NXDRIVE-1339): Handle boolean parameters
- [NXDRIVE-1342](https://jira.nuxeo.com/browse/NXDRIVE-1342): Handle Windows session names with unicode
- [NXDRIVE-1372](https://jira.nuxeo.com/browse/NXDRIVE-1372): Remove some usages of deprecated server-side code

## GUI

- [NXDRIVE-600](https://jira.nuxeo.com/browse/NXDRIVE-600): Use the generic JSP to acquire a token
- [NXDRIVE-969](https://jira.nuxeo.com/browse/NXDRIVE-969): Switch to QML for UI
- [NXDRIVE-1183](https://jira.nuxeo.com/browse/NXDRIVE-1183): Make server UI selection smarter
- [NXDRIVE-1195](https://jira.nuxeo.com/browse/NXDRIVE-1195): Add a setting to let the user choose the icons set
- [NXDRIVE-1231](https://jira.nuxeo.com/browse/NXDRIVE-1231): Add a message box to display fatal errors
- [NXDRIVE-1235](https://jira.nuxeo.com/browse/NXDRIVE-1235): Disable Hebrew language as it is not translated
- [NXDRIVE-1267](https://jira.nuxeo.com/browse/NXDRIVE-1267): Add a notification when DirectEdit starts the download of a file
- [NXDRIVE-1300](https://jira.nuxeo.com/browse/NXDRIVE-1300): Display an error on bad configuration parameters
- [NXDRIVE-1314](https://jira.nuxeo.com/browse/NXDRIVE-1314): Add a placeholder text in server URL

## Packaging / Build

- [NXDRIVE-1217](https://jira.nuxeo.com/browse/NXDRIVE-1217): Hide the Dock icon on macOS
- [NXDRIVE-1223](https://jira.nuxeo.com/browse/NXDRIVE-1223): Use a fork of universal-analytics-python that supports Python 3
- [NXDRIVE-1225](https://jira.nuxeo.com/browse/NXDRIVE-1225): Be specific about pyobjc requirements
- [NXDRIVE-1234](https://jira.nuxeo.com/browse/NXDRIVE-1234): Tweak pyup.io parameters
- [NXDRIVE-1244](https://jira.nuxeo.com/browse/NXDRIVE-1244): Ensure Drive is closed before auto-upgrading on Windows
- [NXDRIVE-1323](https://jira.nuxeo.com/browse/NXDRIVE-1323): Use venv instead of virtualenv on Windows
- [NXDRIVE-1343](https://jira.nuxeo.com/browse/NXDRIVE-1343): Archive a zipped version of the package folder when building installers

## Doc

- [NXDRIVE-1276](https://jira.nuxeo.com/browse/NXDRIVE-1276): Add documentation about Nuxeo Platform support

## Tests

- [NXDRIVE-1212](https://jira.nuxeo.com/browse/NXDRIVE-1212): Disable all server converters, enabled on-demand
- [NXDRIVE-1246](https://jira.nuxeo.com/browse/NXDRIVE-1246): Fix pytest randombug plugin STRICT mode
- [NXDRIVE-1281](https://jira.nuxeo.com/browse/NXDRIVE-1281): Cover the whole DirectEdit feature with tests
- [NXDRIVE-1293](https://jira.nuxeo.com/browse/NXDRIVE-1293): Tweak timeouts in testing jobs on Jenkins
- [NXDRIVE-1316](https://jira.nuxeo.com/browse/NXDRIVE-1316): Only run tests when code files are modified or build is launched manually
- [NXDRIVE-1370](https://jira.nuxeo.com/browse/NXDRIVE-1370): Use a random string for the database name and user in PGSQL

## Minor Changes

- Development: Use the pre-commit tool to ensure a good quality code before committing
- Framework: Make NotFound exception inherits from OSError
- Jenkins: Added the `PYTEST_ADDOPTS` parameter to the Drive-tests job
- Jenkins: Removed the `ENABLE_PROFILER` parameter from the Drive-tests job
- Packaging: Added `distro` 1.3.0
- Packaging: Added `flake8` 3.5.0
- Packaging: Added `nuxeo` 2.0.3
- Packaging: Added `pre-commit` 1.11.2
- Packaging: Updated `markdown` from 2.6.11 to 3.0.1
- Packaging: Updated `psutil` from 5.4.4 to 5.4.7
- Packaging: Updated `pycryptodomex` from 3.6.1 to 3.6.6
- Packaging: Updated `pypac` from 0.8.1 to 0.12.0
- Packaging: Updated `pytest` from 3.5.1 to 3.8.2
- Packaging: Updated `pytest-cov` from 2.5.1 to 2.6.0
- Packaging: Updated `pytest-timeout` from 1.2.1 to 1.3.2
- Packaging: Updated `rfc3987` from 1.3.7 to 1.3.8
- Packaging: Updated `xattr` from 0.9.3 to 0.9.6
- Packaging: Updated `watchdog` from 0.8.4 to 0.9.0
- Packaging: Removed `SIP_VERSION` and `PYQT_VERSION` envars
- Tests: Added `-b -Wall` arguments to the Python interpreter while testing
- Tests: Added `--maxfail=5` argument to pytest
- \[GNU/Linux\] Packaging: Removed `COMPILE_WITH_DEBUG` envar
- \[Windows\] Packaging: Added the `PYTHON_DIR` envar
- \[Windows\] Packaging: Removed `QT_PATH` and `MINGW_PATH` envars
- \[Windows\] Tests: Added `-install` argument
- \[Windows\] Tests: Removed `-direct` argument

## Technical Changes

- Removed `AbstractOSIntegration.is_linux()`
- Removed `AbstractOSIntegration.is_mac()`
- Removed `AbstractOSIntegration.is_windows()`
- Changed `AbstractOSIntegration.register_startup()` return type to `bool`
- Changed `AbstractOSIntegration.unregister_startup()` return type to `bool`
- Added `Application.load_icons_set()`
- Added `Application.initial_icons_set()`
- Added `Application.refresh_conflicts()`
- Added `force` keyword argument to `Application.set_icon_state()`
- Removed `Application.get_htmlpage()`
- Removed `Application.get_cache_folder()`
- Removed `CustomMemoryHandler.flush()`
- Removed `DriveSystrayIcon.use_old_menu`
- Added `Engine.init_remote()`
- Changed `Engine(..., remote_doc_client_factory, remote_fs_client_factory, remote_filtered_fs_client_factory` to `Engine(..., remote_cls, local_cls)`
- Removed `Engine.get_abspath()`
- Added `duration` keyword argument to `Engine.get_last_files()`
- Added `Engine.get_last_files_count()`
- Removed `Engine.add_to_favorites()`
- Removed `Engine.get_local_client()`. Use `local` attribute instead.
- Removed `Engine.get_remote_client()`. Use `remote` attribute instead.
- Removed `Engine.get_rest_api_client()`. Use `remote` attribute instead.
- Removed `Engine.get_server_version()`. Use `remote.client.server_version` attribute instead.
- Removed `Engine.get_update_infos()`
- Removed `Engine.invalidate_client_cache()`
- Added `duration` keyword argument to `EngineDAO.get_last_files()`
- Added `EngineDAO.get_last_files_count()`
- Moved `LocalClient.get_content()` to `LocalTest`
- Moved `LocalClient.update_content()` to `LocalTest`
- Added `Manager.proxy`
- Added `Manager.reloadIconsSet()`
- Added `Manager.set_light_icons()`
- Added `Manager.set_proxy()`
- Added `Manager.use_light_icons()`
- Moved `Manager.get_system_pac_url()` to client/proxy.py
- Moved `Manager.get_default_nuxeo_drive_folder()` to utils.py
- Removed `Manager.aboutToStart()`
- Removed `Manager.app_name`. Use `APP_NAME` constant instead.
- Removed `Manager.clientUpdated()`
- Removed `Manager.engineNotFound()`
- Removed `Manager.exceptions`
- Removed `Manager.get_proxies()`
- Removed `Manager.get_proxy_settings()`
- Removed `Manager.proxies`
- Removed `Manager.refresh_proxies()`
- Removed `Manager.retreive_system_proxies()`
- Removed `Manager.set_exceptions()`
- Removed `Manager.set_proxy_settings()`
- Removed `Manager.proxyUpdated()`
- Removed `Manager.validate_proxy_settings()`
- Removed `Notification.get_content()`
- Changed `fail_on_error` default value to True in `Options.update()`
- Added `Options.home`
- Removed `Options.log_filename`
- Removed `Options.server_version`. Use `Engine.remote.client.server_version` attribute instead.
- Removed `Options.proxy_exceptions`
- Removed `Options.proxy_type`
- Added `duration` keyword argument to `QMLDriveApi.get_last_files()`
- Added `QMLDriveApi.get_last_files_count()`
- Removed `QueueManager.queueEmpty()`
- Added `filtered` keyword argument `Remote.get_fs_children()` with `True` as default value.
- Added `Remote.get_server_configuration()`
- Added `filtered` keyword argument `Remote.is_filtered()` with `True` as default value.
- Added `Remote.set_proxy()`
- Moved `Remote.conflicted_name()` to `RemoteBase`
- Moved `Remote.doc_to_info()` to `NuxeoDocumentInfo.from_dict()`
- Moved `Remote.file_to_info()` to `RemoteFileInfo.from_dict()`
- Removed `last_sync_date` argument from `Remote.get_changes()` as it is deprecated server-side.
- Moved `Remote.get_children()` to `RemoteBase`
- Moved `Remote.get_children_info()` to `RemoteBase`
- Moved `Remote.get_content()` to `RemoteBase`
- Moved `Remote.get_roots()` to `RemoteBase`
- Removed `Remote.get_top_level_children()` as it is deprecated server-side.
- Moved `Remote.make_file()` to `RemoteBase`
- Moved `Remote.update_content()` to `RemoteBase`
- Changed `Translator(object)` to `Translator(QTranslator)``
- Added `Translator.translate()`
- Added `Translator.tr()`
- Removed `types` argument from `Remote.get_children_info()`. Use `types` attribute instead.
- Removed `RemoteWatcher.get_engine()`. Use `engine` attribute instead.
- Removed `Updater.last_status`
- Added `Updater.status`
- Added `Updater.version`
- Added `Updater.progress`
- Added `Updater.updateProgress`
- Renamed `WebAuthenticationApi` to `QMLAuthenticationApi`
- Renamed `WebConflictsApi` to `QMLConflictsApi`
- Removed `WebDialog.loadError()`
- Removed `WebDialog.requestFinished()`
- Renamed `WebDriveApi` to `QMLDriveApi`
- Renamed `WebSettingsApi` to `QMLSettingsApi`
- Renamed `WebSystrayApi` to `QMLSystrayApi`
- Added `WindowsIntegration.register_startup()`
- Added `WindowsIntegration.unregister_startup()`
- Removed `Worker.actionUpdate()`
- Added exceptions.py
- Removed `filter_inotify` argument logging_config.py::`configure()`
- Removed `log_rotate_keep` argument logging_config.py::`configure()`
- Removed `log_rotate_max_bytes` argument logging_config.py::`configure()`
- Removed `log_rotate_when` argument logging_config.py::`configure()`
- Removed `use_file_handler` argument logging_config.py::`configure()`
- Removed application.py::`SimpleApplication`
- Added client/proxy.py
- Added client/remote_client.py
- Removed client/remote_client.py::`FilteredRemote`
- Moved client/common.py::`DuplicationDisabledError` exception to exceptions.py
- Moved client/common.py::`COLLECTION_SYNC_ROOT_FACTORY_NAME` constant to engine/watcher/remote_watcher.py
- Moved client/common.py::`NotFound` exception to exceptions.py
- Moved client/common.py::`UNACCESSIBLE_HASH` constant constants.py
- Moved client/common.py::`safe_filename()` utils.py
- Removed client/base_automation_client.py
- Removed client/common.py
- Removed client/remote_document_client.py
- Removed client/remote_file_system_client.py
- Removed client/remote_filtered_file_system_client.py
- Removed client/rest_api_client.py
- Added constants.py::`APP_NAME`
- Added constants.py::`LINUX`
- Added constants.py::`MAC`
- Added constants.py::`WINDOWS`
- Removed constants.py::`DEFAULT_TYPES`
- Removed constants.py::`MAX_CHILDREN`
- Added data/qml
- Removed data/ui5
- Removed engine/dao/sqlite.py::`FakeLock`
- Moved engine/engine.py::`InvalidDriveException` exception to exceptions.py
- Moved engine/engine.py::`RootAlreadyBindWithDifferentAccount` exception to exceptions.py
- Removed engine/engine.py::`EngineDialog`
- Moved engine/workers.py::`PairInterrupt` exception to exceptions.py
- Moved engine/workers.py::`ThreadInterrupt` exception to exceptions.py
- Added exceptions.py::`UnknownDigest`
- Added gui/conflicts.py::`ConflictsView`
- Removed gui/dialog.py::`TokenNetworkAccessManager`
- Added gui/dialog.py::`TokenRequestInterceptor`
- Removed gui/folders_treeview.py::`DocFileInfo`
- Removed gui/folders_treeview.py::`DocRootFileInfo`
- Removed gui/folders_treeview.py::`FsRootFileInfo`
- Added gui/settings.py::`SettingsView`
- Added gui/systray.py::`SystrayView`
- Added gui/view.py
- Moved logging_config.py::`MAX_LOG_DISPLAYED` to constants.py
- Moved manager.py::`EngineTypeMissing` exception to exceptions.py
- Moved manager.py::`FolderAlreadyUsed` exception to exceptions.py
- Removed manager.py::`MissingToken`
- Removed manager.py::`ProxySettings`
- Removed osi/darwin/darwin.py::`FinderSyncListener`
- Added osi/darwin/darwin.py::`FinderSyncServer`
- Removed osi/darwin/darwin.py::`SocketThread`
- Added updater/utils.py::`get_update_status()`
- Added utils.py::`copy_to_clipboard()`
- Added utils.py::`force_encode()`
- Added utils.py::`if_frozen()`
- Removed utils.py::`version_between()`
- Removed `codecs` argument from utils.py::`force_decode()`
- Removed utils.py::`guess_digest_algorithm()`
- Moved wui/* to gui/*
